import { type UnbindFn } from 'bind-event-listener';
declare class ContrastModeObserver {
    unbindContrastChangeListener: UnbindFn | null;
    getContrastMode(): "more" | "no-preference";
    bind(): void;
    unbind(): void;
}
/**
 * A singleton contrast mode observer - binds "auto" switching logic to a single `mediaQueryList` listener
 * that can be unbound by any consumer when no longer needed.
 */
declare const SingletonContrastModeObserver: ContrastModeObserver;
export default SingletonContrastModeObserver;
